library aursir_polymer.import;

import 'package:polymer/polymer.dart';
import 'dart:convert';
import 'dart:async';
import 'package:yaml/yaml.dart';
import 'package:aursir4dart/exported_appkey.dart';
import 'package:aursir4dart/interface.dart';

@CustomTag('aursir-polymer-export')
class AursirExportElement extends PolymerElement {
    @published AurSirExport asexport;

    @published String appkey;
    @published String appkey_yaml = "";
    @published List<String> tags = [];

    @observable AurSirInterface interface;

    AursirExportElement.created(): super.created();

    void detached() => asexport.remove();

    void onDocked(){
      Map parsedKey;
      if (appkey_yaml != "") parsedKey = loadYaml(appkey_yaml);
      else parsedKey = JSON.decode(appkey);

      interface.addExport(parsedKey,tags).then((AurSirExport e) {
        asexport = e;

        new Timer(new Duration(milliseconds:1), () => fire("export-ready"));

      });
    }
}
